	.text
	.arm
	.align
	
	@ definition
	GBA_INT_REG_IF  = 0x04000202
	GBA_INT_REG_IME = 0x04000
	
	@ global functions called by HAL
	.globl	HalpIrqHandler
	
@ -----------
@ Irq Handler
@ -----------
HalpIrqHandler:
	ldr		r0, =GBA_INT_REG_IF
	ldr		r0, [r0]
	
	ands	r1, r0, #0x40				@ is timer3(scheduling) interrupt?
	bne		TmCallIrqScheduler			@ then, call stack building procedure
	bl		HalpIrqHandlerMain			@ others, the irq handler dispatch it!
	
	ldmfd	sp!, {r0, r1, r2, r3, r12, lr}
	subs	pc, lr, #4
	
